-- I wanna take a nap
-- splitscreen is unsupported as of yet
-- GenericHeroGuy: now it is! ...sort of
-- G from future: it definitely is now!

local gl, aimingtodyfix
rawset(_G, "SG_GetScreenCoords", function(v, p, c, target, hofs, dontclip)
	if not target then return end
	local camx, camy, camz, camangle, camaiming

	if not gl then
		gl = v.renderer() == "opengl"
		-- uhhhhhhh how do i detect this
		-- send help
		aimingtodyfix = string.find(VERSIONSTRING, "Saturn", 0, true)
		or string.find(VERSIONSTRING, "Galaxy", 0, true)
		or string.find(VERSIONSTRING, "Planeptune", 0, true)
	end

	if p.awayviewtics then
		camx = p.awayviewmobj.x
		camy = p.awayviewmobj.y
		camz = p.awayviewmobj.z
		camangle = p.awayviewmobj.angle
		camaiming = p.awayviewaiming
	elseif c.chase then
		camx = c.x
		camy = c.y
		camz = c.z + (p.mo.eflags & MFE_VERTICALFLIP and c.height)
		camangle = c.angle
		camaiming = c.aiming
	else
		camx = p.mo.x
		camy = p.mo.y
		camz = p.viewz
		camangle = p.mo.angle
		camaiming = p.aiming
	end

	local fovval = CV_FindVar("fov").value
	local xres = v.width()<<(FRACBITS-1)
	local yres = v.height()<<(FRACBITS-1)
	local fov = FixedDiv(xres, tan(FixedAngle(fovval/2), true))

	-- X coordinate
	-- get difference between camangle and angle towards target
	local x = camangle - R_PointToAngle2(camx, camy, target.x, target.y)

	local distfact = cos(x) or 1
	if encoremode then x = -x end -- flip on encore
	if x < ANGLE_270 or x > ANGLE_90 then return end -- clip points behind the camera

	-- we'll project the X coordinate later, because it might need some extra perspective

	-- flipping
	local targflip = target.eflags & MFE_VERTICALFLIP
	local srcflip = p.pflags & PF_FLIPCAM and p.mo.eflags & MFE_VERTICALFLIP

	-- Y coordinate
	-- getting the angle difference here is a bit more involved...
	-- start by getting the height difference between the camera and target
	local y = camz - target.z - (targflip and target.height)
	if hofs then y = y - (targflip and -hofs or hofs) end

	-- then get the distance between camera and target
	local dist = R_PointToDist2(camx, camy, target.x, target.y)

	-- NOW we can get the angle difference
	if gl and CV_FindVar("gr_shearing").value == 0 then -- OpenGL
		local yang = R_PointToAngle2(0, 0, dist, y) -- not perspective
		x = FixedMul(x, cos(yang)) -- perspective
		y = -camaiming - FixedDiv(yang, distfact)
		if y < ANGLE_270 or y > ANGLE_90 then return end -- clip points behind the camera
		if splitscreen == 1 then y = $ + ($/4) end -- multiply by 1.25 for 2P splitscreen
		if srcflip then y = -y end -- flipcam
		y = FixedMul(tan(-y, true), fov) + yres -- project the angle to get our final Y coordinate
	else -- software
		local fovratio = FixedDiv(90*FRACUNIT, 180*FRACUNIT - FixedMul(fovval, 4*FRACUNIT/3)-FRACUNIT*-30)

		y = FixedDiv(y, FixedMul(dist, distfact))
		if srcflip then y = -y end -- flipcam
		if y ~= INT32_MIN then -- I_Error(): FixedDiv: divide by zero
			y = FixedMul(FixedDiv(y, fovratio), xres) + yres
		--else print("NOPE!")
		end

		local offset = FixedMul(tan(camaiming, true), xres)
		-- this isn't fovtan... what am i even doing anymore
		if splitscreen == 1 then offset = 17*offset/10 end
		-- OpenGL with software perspective is miscentered on non-16:10 resolutions
		if gl then offset = FixedMul($, FixedDiv(104857, FixedDiv(xres, yres))) end
		-- thanks fickle
		if aimingtodyfix then offset = FixedDiv($, fovratio) end
		if srcflip then offset = -offset end -- flipcam
		y = y + offset
	end

	-- project the angle to get our final X coordinate
	x = FixedMul(tan(x, true), fov)
	if splitscreen == 1 then x = ($/2) + ($/8) end -- divide by 320/200 (1.6) on 2P splitscreen
	x = $ + xres

	-- now clip in screen-space
	if not dontclip and (x < 0 or x > xres*2 or y < 0 or y > yres*2) then return end

	-- get splitscreen index
	local splitindex = c.pnum - 1
	--[[ thanks toaster/lat/whoever for never documenting c.pnum
	local splitindex
	for dp, i in displayplayers.iterate do
		if p == dp then splitindex = i end
	end
	--]]

	-- adjust coords for splitscreen
	if splitscreen == 1 then -- 2P
		y = $>>1
		if splitindex then y = y + yres end
	end
	if splitscreen >= 2 then -- 3P or 4P
		x = x>>1
		y = y>>1
		if splitindex & 1 then x = x + xres end
		if splitindex >= 2 then y = y + yres end
	end

	return x, y, targflip ~= srcflip
end)

rawset(_G, "SG_DrawPaddedNum", function(v, x, y, num, digits, font, flags, cmap)
	num = tostring(abs(num)) -- always positive

	-- pad number to required digits
	num = string.format("%0"..digits.."d", num)

	-- draw each digit
	for i = #num, 1, -1 do
		local patch = v.cachePatch(font..string.sub(num, i, i))
		x = $ - (patch.width - 1) * (flags & V_NOSCALESTART and v.dupx() or 1)
		v.draw(x, y, patch, flags, cmap)
	end
end)

local driftcolors = {
	-- top  --  bottom --
	{0, 0, 10, 16},       -- no drift
	{215, 215, 204, 253}, -- blue
	{125, 125, 151, 159}  -- red
}

local driftskins = {
	SKINCOLOR_NONE,
	SKINCOLOR_TEAL,
	SKINCOLOR_SALMON,
}

local driftrainbow = {
	0, 31, 47, 63, 79, 95, 111, 119, 127, 143, 159, 175, 183, 191, 199, 207, 223, 247
}

local cv_driftgauge = CV_RegisterVar{
	name = "driftgauge",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
	config_menu = "HUD",
	displayname = "Driftgauge",
	description = "Display your drift level below your character."
}

local cv_driftgaugeofs = CV_RegisterVar{
	name = "driftgaugeoffset",
	defaultvalue = "-20",
	flags = CV_FLOAT,
	possiblevalue = { MIN = -FRACUNIT*128, MAX = FRACUNIT*128 },
	config_menu = "HUD",
	displayname = "Driftgauge offset",
	description = "Vertical offset for driftgauge.",
	config_hudmove = true,
	config_hudcall = function(v, p, c, var)
		if not (p.mo and c.chase and p.playerstate == PST_LIVE) then return end
		local basex, basey = SG_GetScreenCoords(v, p, c, p.mo, FixedMul(var.value, var.value > 0 and p.mo.scale or mapobjectscale))
		if not basex then return end
		basex, basey = $>>FRACBITS, $>>FRACBITS
		v.draw(basex, basey, v.cachePatch("K_DGAU"), V_NOSCALESTART|V_OFFSET)
		local dup = v.dupx()
		v.drawFill(basex - dup*23, basey - dup, dup*46, dup*4, (leveltime % 32) | V_NOSCALESTART)
	end
}

local cv_driftgaugetrans = CV_RegisterVar{
	name = "driftgaugetransparency",
	defaultvalue = "Off",
	possiblevalue = CV_OnOff,
	config_menu = "HUD",
	displayname = "Driftgauge transparency",
	description = "Make the driftgauge follow your HUD transparency."
}

local cv_driftgaugecolorized = CV_RegisterVar{
	name = "driftgaugecolorized",
	defaultvalue = "Off",
	possiblevalue = CV_OnOff,
	config_menu = "HUD",
	displayname = "Driftgauge color",
	description = "Colorize driftgauge background. Inverted if colorizedhud is enabled."
}

local cv_colorizedhud
local cv_colorizedhudcolor

-- Latest saturn would have better functions for this but before release i do it like that for now
local function useColorizedHud()
    if cv_colorizedhud == nil then
        cv_colorizedhud = CV_FindVar("colorizedhud") or false
        cv_colorizedhudcolor = CV_FindVar("colorizedhudcolor") or false
    end

    if cv_colorizedhud then
        return cv_colorizedhud.value ~= cv_driftgaugecolorized.value
    end

    return cv_driftgaugecolorized.value
end

local function getBackgroundPatch(v)
    return v.cachePatch(useColorizedHud() and "K_DGAUC" or "K_DGAU")
end

local function getBackgroundColormap(v, p)
    if not useColorizedHud() then return end

    return v.getColormap(TC_RAINBOW, cv_colorizedhudcolor and cv_colorizedhudcolor.value or p.skincolor)
end


hud.add(function(v, p, c)
	if not (p.mo and c.chase and p.kartstuff[k_drift] and cv_driftgauge.value and p.playerstate == PST_LIVE) then return end

	local driftval = K_GetKartDriftSparkValue(p)
	local driftcharge = min(driftval*4, p.kartstuff[k_driftcharge])

	local basex, basey = SG_GetScreenCoords(v, p, c, p.mo, FixedMul(cv_driftgaugeofs.value, cv_driftgaugeofs.value > 0 and p.mo.scale or mapobjectscale))
	if not basex then return end
	basex, basey = $>>FRACBITS, $>>FRACBITS
	local dup = v.dupx()
	
	local drifttrans
	
	if string.find(VERSIONSTRING:lower(), "saturn") and cv_driftgaugetrans.value then -- only use this in saturn since other clients dont support translucent drawfill or stuff will look off!
		drifttrans = v.localTransFlag()
	else
		drifttrans = 0
	end

	v.draw(basex, basey, getBackgroundPatch(v), V_NOSCALESTART|V_OFFSET|drifttrans, getBackgroundColormap(v, p))

	local barx = basex - dup*23
	local bary = basey - dup*2
	local BAR_WIDTH = dup*47

	local limit = driftval * (driftcharge >= driftval*2 and 2 or 1)
	local width = ((driftcharge - (driftcharge >= driftval and limit or 0)) * BAR_WIDTH) / limit 
	local level = min(driftcharge / driftval, 2) + 1

	local cmap
	if driftcharge >= driftval*4 then -- rainbow sparks
		cmap = v.getColormap(TC_RAINBOW, 1 + leveltime % (MAXSKINCOLORS-1))
		for i = 1, 4 do
			v.drawFill(barx, bary+dup*i, BAR_WIDTH, dup, (driftrainbow[(leveltime % #driftrainbow) + 1] + i*2) | V_NOSCALESTART|drifttrans)
		end
	else -- none/blue/red
		cmap = v.getColormap(TC_RAINBOW, driftskins[level])
		for i = 1, 4 do
			if driftcharge >= driftval then
				v.drawFill(barx, bary+dup*i, BAR_WIDTH, dup, driftcolors[level-1][i] | V_NOSCALESTART|drifttrans)
			end
			v.drawFill(barx, bary+dup*i, width, dup, driftcolors[level][i] | V_NOSCALESTART|drifttrans)
		end
	end

	-- right, also draw a cool number
	SG_DrawPaddedNum(v, basex + (dup*32), basey, driftcharge*100 / driftval, 3, "PINGN", V_NOSCALESTART|V_OFFSET|drifttrans, cmap)
end)
