-- Toggle neoroulette off when in low player lobby
local cv_enabled = CV_RegisterVar {
    name = "nra_enabled",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR, -- Not necessary but will not make any sense to allow that be modified by non-server players
}

local cv_minplayers = CV_RegisterVar {
    name = "nra_minplayers",
    defaultvalue = "7",
    possiblevalue = CV_Natural,
    flags = CV_NETVAR, -- Not necessary but will not make any sense to allow that be modified by non-server players
}

local vanilla = false

addHook("NetVars", function(net)
    vanilla = net($)
end)

addHook("ThinkFrame", function()
    --if not isserver then return end

    local numplayers = 0

    for p in players.iterate do
        if not p.spectator then numplayers = $ + 1 end
    end

    if not vanilla and numplayers < cv_minplayers.value then
        vanilla = true

        COM_BufInsertText(server, "nr_enabled Off")
        print("\131Neoroulette: \128Below 7 players, vanilla item odds & calculations active.")
        return
    end

    if vanilla and numplayers >= cv_minplayers.value then
        vanilla = false

        COM_BufInsertText(server, "nr_enabled On")
        print("\131Neoroulette: \1287 players or more, Transcendence/CEP item odds & calculations active.")
    end
end)
